import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] g = new int[n];
        for (int i = 0; i < n; i++) {
            g[i] = nextInt() - 1;
        }
        int[][] lines = new int[n/2][n];
        int next, current = 0, index;
        int[] pointers = new int[n/2];
        lines[0][0] = 0;
        pointers[0] = 1;
        boolean[] hasBeen = new boolean[n];
        hasBeen[0] = true;
        boolean finished = false;
        for (int i = 1; i < n; i++) {
            next = g[lines[current][pointers[current] - 1]];
            if(next != lines[current][0]){
                lines[current][pointers[current]] = next;
                pointers[current]++;
                hasBeen[next] = true;
            }
            else{
                current++;
                index = 0;
                while(hasBeen[index]) {
                    index++;
                    if(index == n){
                        finished = true;
                        break;
                    }
                }
                if(finished)
                    break;
                next = index;
                hasBeen[next] = true;
                lines[current][0] = next;
                pointers[current] = 1;
            }
        }
        int count = 0, l;
        int[] first = new int[n/2];
        int[] second = new int[n/2];
        int nextNull1 = 0;
        int nextNull2 = 0;
        for (int i = 0; i <= current; i++) {
            l = pointers[i];
            if(l % 2 == 0){
                for (int j = 0; j < l; j+=2) {
                    first[nextNull1] = lines[i][j];
                    nextNull1++;
                }
            }
            else{
                count++;
                for (int j = 0; j < l-1; j+=2) {
                    first[nextNull1] = lines[i][j];
                    nextNull1++;
                }
            }
            for (int j = 1; j < l; j+=2) {
                second[nextNull2] = lines[i][j];
                nextNull2++;
            }
        }
        out.println(count);
        for (int i = 0; i < nextNull1; i++) {
            out.print(first[i] + 1);
            out.print(' ');
        }
        out.println();
        for (int i = 0; i < nextNull2; i++) {
            out.print(second[i] + 1);
            out.print(' ');
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}