import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt(), k = nextInt();
        boolean[] isReached = new boolean[n];
        isReached[0] = true;
        int[] a = new int[n];
        a[0]  = nextInt();
        int next, nextNull = 1;
        StringBuilder result = new StringBuilder("1");
        for (int i = 1; i < n; i++) {
            next = nextInt();
                if (Math.abs(a[nextNull-1] - next) <= k) {
                    isReached[i] = true;
                    break;
                }

            if(isReached[i]){
                result.append('1');
                a[nextNull] = next;
                nextNull++;
            }
            else result.append('0');
        }
        out.println(result);
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}