import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt(), k = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = 1000000001;
        }
        a[0]  = nextInt();
        int next, nextNull = 1, index;
        StringBuilder result = new StringBuilder("1");
        for (int i = 1; i < n; i++) {
            next = nextInt();
            if(next >= a[0] - k && next <= a[nextNull - 1] + k) {
                result.append('1');
                index = 0;
                while(next > a[index] && index < n-1)
                    index++;
                for (int j = nextNull; j > index; j--) {
                    a[j] = a[j-1];
                }
                a[index] = next;
                nextNull++;
            }
            else result.append('0');
        }
        out.println(result);
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}