import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int[] g = new int[n];
        for (int i = 0; i < n; i++) {
            g[i] = nextInt() - 1;
        }
        //int[][] lines = new int[n/2][n];
        int next, current = 0, index;
        int[] pointers = new int[n/2];
        pointers[0] = 1;
        boolean[] hasBeen = new boolean[n];
        hasBeen[0] = true;
        boolean finished = false;
        int count = 0, l;
        int[] first = new int[n/2 + 1];
        first[0] = 0;
        int[] second = new int[n/2 + 1];
        int nextNull1 = 1;
        int nextNull2 = 0;
        int firstElement = 0, lastElement = 0;
        for (int i = 0; i < n; i++) {
            next = g[lastElement];
            if(next != firstElement){
                lastElement = next;
                pointers[current]++;
                hasBeen[next] = true;
            }
            else{
                if(pointers[current] % 2 != 0){
                    count++;
                    if(nextNull1 > nextNull2)
                        nextNull1--;
                    else nextNull2--;
                }
                current++;
                index = 0;
                while(hasBeen[index]) {
                    index++;
                    if(index == n){
                        finished = true;
                        break;
                    }
                }
                if(finished)
                    break;
                next = index;
                hasBeen[next] = true;
                firstElement = next;
                lastElement = next;
                pointers[current] = 1;
            }
            if(pointers[current] % 2 == 1){
                first[nextNull1] = next;
                nextNull1++;
            }
            else{
                second[nextNull2] = next;
                nextNull2++;
            }
        }
        out.println(count);
        for (int i = 0; i < nextNull1; i++) {
            out.print(first[i] + 1);
            out.print(' ');
        }
        out.println();
        for (int i = 0; i < nextNull2; i++) {
            out.print(second[i] + 1);
            out.print(' ');
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}