import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt(), k = nextInt();
        int[] status = new int[n];
        status[0] = 1;
        for (int i = 1; i < n; i++) {
            status[i] = 0;
        }
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int numberOfOnes = 1;
        int point = 0, value;
        while(numberOfOnes > 0){
            while(status[point] != 1)
                point++;
            value = a[point];
            for (int i = point + 1; i < n; i++) {
                if (Math.abs(a[i] - value) <= k){
                    if (status[i] == 0){
                        status[i] = 1;
                        numberOfOnes++;
                    }
                }
            }
            status[point] = 2;
            numberOfOnes--;
        }
        StringBuilder result = new StringBuilder("1");
        for (int i = 1; i < n; i++) {
            if(status[i] > 0)
                result.append('1');
            else
                result.append('0');
        }
        out.println(result);
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}