import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long k = nextLong(), sum = 0;
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            sum  += nextInt();
            a[i] = sum;
        }
        int min = n + 1, index = 0;
        long need;
        for (int start = 0; start < n; start++) {
            if(start == 0)
                need = k;
            else
                need = a[start - 1] + k;
            while(index < n && a[index] < need)
                index++;
            if(index != n && index - start + 1 < min)
                min = index - start + 1;
        }
        if(min == n + 1)
            out.println(-1);
        else
            out.println(min);
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}